define("io.ox/backbone/mini-views/alarms",["io.ox/calendar/util","io.ox/backbone/views/disposable","gettext!io.ox/calendar","settings!io.ox/calendar","less!io.ox/backbone/mini-views/alarms"],function(e,t,a,i){"use strict";var r=i.get("availableAlarmTypes",["DISPLAY","AUDIO","EMAIL"]),n={DISPLAY:a("Notification"),AUDIO:a("Audio"),EMAIL:a("Mail"),"X-SMS":a("SMS")},s={"START-":a("before start"),START:a("after start"),"END-":a("before end"),END:a("after end")},o={"DISPLAYSTART-":a("Notify %1$s before start."),DISPLAYSTART:a("Notify %1$s after start."),"DISPLAYEND-":a("Notify %1$s before end."),DISPLAYEND:a("Notify %1$s after end."),DISPLAYABS:a("Notify at %1$s."),DISPLAYSTART0:a("Notify at start."),DISPLAYEND0:a("Notify at end."),"AUDIOSTART-":a("Play sound %1$s before start."),AUDIOSTART:a("Play sound %1$s after start."),"AUDIOEND-":a("Play sound %1$s before end."),AUDIOEND:a("Play sound %1$s after end."),AUDIOABS:a("Play sound at %1$s."),AUDIOSTART0:a("Play sound at start."),AUDIOEND0:a("Play sound at end."),"EMAILSTART-":a("Send mail %1$s before start."),EMAILSTART:a("Send mail %1$s after start."),"EMAILEND-":a("Send mail %1$s before end."),EMAILEND:a("Send mail %1$s after end."),EMAILABS:a("Send mail at %1$s."),EMAILSTART0:a("Send mail at start."),EMAILEND0:a("Send mail at end."),"GENERICSTART-":a("%1$s %2$s before start."),GENERICSTART:a("%1$s %2$s after start."),"GENERICEND-":a("%1$s %2$s before end."),GENERICEND:a("%1$s %2$s after end."),GENERICABS:a("%1$s at %2$s."),GENERICSTART0:a("%1$s at start."),GENERICEND0:a("%1$s at end.")},l=t.extend({className:"alarms-view",events:{"click .alarm-remove":"onRemove","change .alarm-action":"updateModel","change .alarm-time":"updateModel","change .alarm-related":"updateModel"},initialize:function(e){this.options=e||{},this.attribute=e.attribute||"alarms",this.phoneNumber=e.phoneNumber,this.supportedTypes=e.phoneNumber?r:_(r).without("X-SMS"),this.list=$('<div class="alarm-list">'),this.model&&this.listenTo(this.model,"change:"+this.attribute,this.updateView)},render:function(){var t=this;return this.$el.empty().append(t.list,$('<button class="btn btn-default" type="button">').text(a("Add reminder")).on("click",function(){var a;a="alarms"===t.attribute&&t.model?e.isAllday(t.model)?"-PT12H":"-PT15M":"chronos/defaultAlarmDate"===t.attribute||"birthdays/defaultAlarmDate"===t.attribute?"-PT12H":"-PT15M";var i=-1===_(r).indexOf("DISPLAY")?r[0]||"DISPLAY":"DISPLAY",n=t.createNodeFromAlarm({action:i,trigger:{duration:a,related:"START"}});t.list.append(n),n.find(".alarm-action").focus(),t.updateModel()})),this.updateView(),this},onRemove:function(e){e.stopPropagation(),$(arguments[0].target).closest(".alarm-list-item").remove(),this.updateModel()},updateModel:function(){this.model&&(this.changedByUser=!0,this.model.set(this.attribute,this.getAlarmsArray()),this.changedByUser=!1)},updateView:function(){if(!this.changedByUser){var e=this;this.list.empty().append(this.model?_(this.model.get(this.attribute)).map(e.createNodeFromAlarm.bind(e)):[])}},createNodeFromAlarm:function(t,i){if(i=(i||this.list.children().length)+1,t&&t.trigger){var r,o,l=_.uniqueId();if(o=$('<fieldset class="alarm-list-item">').data("id",t.uid).append($('<legend class="sr-only">').text(a("Reminder %1$d",i)),r=$('<div class="item">')),1===this.supportedTypes.length||-1===_(this.supportedTypes).indexOf(t.action)?r.append($('<div class="alarm-action" tabindex="0">').text(n[t.action]||t.action).val(t.action)):r.append($('<label class="sr-only">').attr("for","action-"+l).text(a("type")),$('<select class="form-control alarm-action">').attr("id","action-"+l).append(_(this.supportedTypes).map(function(e){return $("<option>").text(n[e]||e).val(e)})).val(t.action)),t.trigger.duration){var d,m;r.append($('<label class="sr-only">').attr("for","time-"+l).text(a("timeframe")),d=$('<select class="form-control alarm-time">').attr("id","time-"+l).append(_.map(e.getReminderOptions(),function(e,t){return'<option value="'+t+'">'+e+"</option>"})),$('<label class="sr-only">').attr("for","related-"+l).text(a("timeframe relation")),m=$('<select class="form-control alarm-related">').attr("id","related-"+l).append(_.map(s,function(e,t){return'<option value="'+t+'">'+e+"</option>"}))),-1===_(_(e.getReminderOptions()).keys()).indexOf(t.trigger.duration.replace("-",""))&&(/^[-+]?PT0[SHDW]$/.test(t.trigger.duration)?d.find('[value="PT0M"]').val(t.trigger.duration.replace("-","")):d.append($("<option>").val(t.trigger.duration.replace("-","")).text(new moment.duration(t.trigger.duration).humanize()))),m.val((t.trigger.related||"START")+t.trigger.duration.replace(/\w*/g,"")),d.val(t.trigger.duration.replace("-",""))}else r.append($('<div class="alarm-time" tabindex="0">').text(new moment(t.trigger.dateTime).format("LLL")).val(t.trigger.dateTime));return r.append($('<button type="button" class="btn btn-link alarm-remove">').attr("aria-label",a("Remove reminder")).append($('<i class="fa fa-trash">'))),o}},getAlarmsArray:function(){var e=this;return _(this.list.children()).map(function(t){var a={action:$(t).find(".alarm-action").val()},i=$(t).find(".alarm-time").val(),r=$(t).find(".alarm-related").val();switch(0===i.indexOf("-P")||0===i.indexOf("P")?a.trigger={duration:r.replace(/\w*/g,"")+i,related:r.replace(/\W*/g,"")}:a.trigger={dateTime:i},$(t).data("id")&&(a=_.extend(_(e.model.get("alarms")).findWhere({uid:$(t).data("id")}),a)),a.action){case"DISPLAY":a.description||(a.description=e.model?e.model.get("summary")||"reminder":"reminder");break;case"X-SMS":a.description||(a.description=e.model?e.model.get("summary")||"reminder":"reminder"),!a.attendees&&e.phoneNumber&&(a.attendees=[{uri:"tel:"+e.phoneNumber}])}return a})}});return{linkView:t.extend({className:"alarms-link-view",events:{"click .alarm-link":"openDialog"},initialize:function(e){this.options=e||{},this.attribute=e.attribute||"alarms",this.model&&this.listenTo(this.model,"change:"+this.attribute,this.render)},render:function(){return this.$el.empty().append(0===(this.model.get(this.attribute)||[]).length?$('<button type="button" class="alarm-link btn btn-link">').text(a("No reminder")):this.drawList()),this},drawList:function(){var t=$('<ul class="list-unstyled alarm-link-list">');return _(this.model.get(this.attribute)).each(function(i){if(i&&i.trigger){var r,n=[];i.trigger.duration?(n.push(e.getReminderOptions()[i.trigger.duration.replace("-","")]||new moment.duration(i.trigger.duration).humanize()),r=(i.trigger.related||"START")+(-1===i.trigger.duration.indexOf("PT0")?i.trigger.duration.replace(/\w*/g,""):"0")):(n.push(new moment(i.trigger.dateTime).format("LLL")),r="ABS"),n.push(i.action),n.unshift(o[i.action+r]||o["GENERIC"+r]),t.append($("<li>").append($('<button type="button" class="alarm-link btn btn-link">').text(a.format.apply(void 0,n))))}}),t},openDialog:function(e){e=e||{};var t=this;require(["io.ox/backbone/views/modal","io.ox/core/api/user"],function(i,r){r.get({id:e.userId}).always(function(e){var r,n={},s=(e=e||{}).cellular_telephone1||e.cellular_telephone2;n[t.attribute]=_.deepClone(t.model.get(t.attribute)),r=new l({model:new Backbone.Model(n),attribute:t.attribute,phoneNumber:s}),new i({title:a("Edit reminders"),width:600}).build(function(){this.$body.append(r.render().$el),this.$el.addClass("alarms-view-dialog")}).addCancelButton({left:!0}).addButton({action:"apply",label:a("Apply")}).on("apply",function(){t.model.trigger("userChangedAlarms"),t.model.set(t.attribute,r.getAlarmsArray()).trigger("change:"+t.attribute)}).open()})})}}),alarmsView:l}});